/*
 
 This file is licensed under the terms of the CC-LGPL
 
 CL_rlp_quadratic_test.pov
 
*/
  ////
 //   example   //
//_____________//
#version 3.7;
#global_settings{assumed_gamma 1.0 charset utf8}   // Remove this and get s for spaces, i.e. DON'T remove this.
//
#include "colors.inc"
#include "rlp.inc"    // Sam Benge's rounded linear prism #macros, available from the Object Collection.
#include "CL_rlp_capital_letters_160714.inc" 
//
// Set up a load of globals that can be passed as arguments into all the routines.
//  
#declare char_type = 4; // 1 chamfered edge, 2 chamfered edge, rounded corners, 3 rounded edge, 4 rounded edge, rounded corners
// 
CL_rlp_make_text_string_set(char_type) // Defines CL_tiny_space,CL_small_space,CL_medium_space,CL_large_space,CL_huge_space,
//                                                CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
//                                                CL_dimensions_out, CL_debug_lines as globals 
#declare CL_debug_lines = 0;  // 0 for no debug lines and messages, 1 for debug lines and messages,
//
// Solving a quadratic equation         
//
#declare equation_dims       = array[4]{0,0,0,0};
#declare equation_obj        = object{CL_rlp_make_text_string("If #ax^2 + bx + c  =  0#, then",CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,
                                                              CL_d_rad,CL_offs,CL_cham,CL_font_type,equation_dims)} 
//
#declare discriminant_dims   = array[4]{0,0,0,0};
#declare discriminant_obj    = object{CL_rlp_make_text_string("# b^2 - 4ac",CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,
                                                              CL_d_rad,CL_offs,CL_cham,CL_font_type,discriminant_dims)} 
//
#declare disc_surd_dims      = array[4]{0,0,0,0};
#declare disc_surd_obj       = object{CL_rlp_make_elastic_surd(CL_medium_space,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                               discriminant_obj,CL_medium_space,0,discriminant_dims,disc_surd_dims)}
//
#declare minusbpm_dims       = array[4]{0,0,0,0};
#declare minusbpm_obj        = object{CL_rlp_make_text_string("#-b |+ ",CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,
                                                              CL_d_rad,CL_offs,CL_cham,CL_font_type,minusbpm_dims)} 
//
#declare frac_top_dims       = array[4]{0,0,0,0};
#declare part_dims           = array[2]{minusbpm_dims,disc_surd_dims};
#declare frac_top_obj        = object{CL_rlp_make_concatenate(minusbpm_obj,disc_surd_obj,CL_medium_space,part_dims,frac_top_dims)}
//
#declare twoa_dims           = array[4]{0,0,0,0};
#declare twoa_obj            = object{CL_rlp_make_text_string("#2a",CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,
                                                              CL_d_rad,CL_offs,CL_cham,CL_font_type,twoa_dims)} 
//
#declare x12_dims            = array[4]{0,0,0,0};
#declare x12_obj             = object{CL_rlp_make_text_string("#x_1_,_2",CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,
                                                              CL_d_rad,CL_offs,CL_cham,CL_font_type,x12_dims)} 
//
#declare rhs_dims            = array[4]{0,0,0,0};
#declare fraction_dimensions = array[2]{frac_top_dims,twoa_dims};
#declare rhs_obj             = object{CL_rlp_make_fraction(CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,frac_top_obj,twoa_obj,
                                                           CL_medium_space,fraction_dimensions,rhs_dims)}   
//                                                       
#declare part_dims           = array[2]{x12_dims,rhs_dims}; 
#declare middle_obj          = 0;
#declare my_maths_object     = object{CL_rlp_make_equation(CL_tiny_space,CL_letter_adjust,CL_z1,CL_z2,CL_d_rad,CL_offs,CL_cham,CL_font_type,
                                                           x12_obj,rhs_obj,middle_obj," = ",CL_medium_space,part_dims,CL_dimensions_out)} 
#declare relation_middle     = CL_dimensions_out[2]; // This is the x coord of the middle of the relationship, so you can line up, e.g. equals signs.
//
object{equation_obj    translate <-equation_dims[0]/2,2,0> pigment{rgb 1} finish{ambient 0 specular 1}}  
object{my_maths_object translate <-CL_dimensions_out[0]/2,-3.5,0> pigment{rgb 1} finish{ambient 0 specular 1}}  
//
  ////
 //  end example  //
//_______________//
light_source{<0,20,-25>, 4 fade_power 2 fade_distance 10
  #if(0)
    area_light x*2,y*2,8,8
    jitter adaptive 2
    area_illumination
  #end
            }
//
camera{orthographic 
       location<0,(CL_dimensions_out[1]-CL_dimensions_out[3])/2,-4*max(equation_dims[0],CL_dimensions_out[0])> 
       look_at <0,(CL_dimensions_out[1]-CL_dimensions_out[3])/2,0> 
       angle 15
      }

